function Create(self)
--LEVITATION
	self.aimThreshold = 0;
	
	self.sensorRange = 500;
	self.target = nil;
	self.gunOffset = 13;
	
	self.maxSpeed = 5;
	self.acceleration = 0.2;
	self.Vel = Vector(0,0);
	self.RotAngle = 0;
	self.rotFactor = 0.2;
	
	self.gravTester = CreateMOPixel("Monolith Grav Tester");
	self.gravTester.Pos = Vector(self.Pos.X, self.Pos.Y - 3);
	self.gravTester.Vel = Vector(0,0);
	MovableMan:AddParticle(self.gravTester);
	self.gravAcc = 0;

--SIDE GUNS
	self.sideOffset = Vector(22, 0);

	self.RSide = CreateACrab("Side");
	self.RSide.Team = self.Team;
	self.RSide.Pos = Vector(self.Pos.X + self.sideOffset.X, self.Pos.Y + self.sideOffset.Y);
	self.RSide.RotAngle = self.RotAngle;
	self.RSide.Vel = self.Vel;
	self.RSide.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(self.RSide);
	
	self.LSide = CreateACrab("Side");
	self.LSide.Team = self.Team;
	self.LSide.Pos = Vector(self.Pos.X - self.sideOffset.X, self.Pos.Y + self.sideOffset.Y);
	self.LSide.RotAngle = self.RotAngle;
	self.LSide.Vel = self.Vel;
	self.LSide.AIMode = Actor.AIMODE_SENTRY;
	MovableMan:AddActor(self.LSide);

--SPAWN
    --Create a timer to time spawnings.
    self.spawnTimer = Timer();
    --How long the spawn interval should be (in milliseconds).
    self.spawnInterval = 120000;--240000;
    --The spawn offset from this actor's center.
    self.offset = Vector(60,20);
	
--REGENERATION
	self.regenTimer = Timer();
end

function Update(self)
--LEVITATION
	if not(self:IsDead()) then
		if self.gravAcc == 0 then
			if self.gravTester.Vel.Y > 0 then
				self.gravAcc = self.gravTester.Vel.Y;
			end
		end

		local ownController = self:GetController();
		
		if not(ownController:IsPlayerControlled(-1)) then
			self:SetControllerMode(Controller.CIM_DISABLED, -1);
			ownController:SetState(Controller.WEAPON_FIRE, false);
			
			if self.target == nil then
				for actor in MovableMan.Actors do
					local distX = actor.Pos.X - self.Pos.X;
					local distY = actor.Pos.Y - (self.Pos.Y + self.gunOffset);
					local distance = math.sqrt(distX ^ 2 , distY ^ 2);
					if actor.Team ~= self.Team and distance <= self.sensorRange and not(actor:IsDead()) then
						local found = SceneMan:CastMORay(Vector(self.Pos.X, self.Pos.Y + self.gunOffset), Vector(distX, distY), self.ID, 128, false, 2);
						local foundRoot = MovableMan:GetRootMOID(found);
						if foundRoot == actor.ID then
							local actorAngle = math.atan2(distY, distX) * -1;
							if actorAngle > math.pi / 2 or actorAngle < math.pi / -2 then
								ownController:SetState(Controller.MOVE_LEFT, true);
							else
								ownController:SetState(Controller.MOVE_RIGHT, true);
							end
							if actorAngle > math.pi / 2 then
								actorAngle = math.pi - actorAngle;
							end
							if actorAngle < math.pi / -2 then
								actorAngle = (math.pi * -1) - actorAngle;
							end
							self.target = actor;
							self:SetAimAngle(actorAngle);
							ownController:SetState(Controller.WEAPON_FIRE, true);
							
							break;
						end
					end
				end
			else
				if MovableMan:ValidMO(self.target) then
					local distX = self.target.Pos.X - self.Pos.X;
					local distY = self.target.Pos.Y - (self.Pos.Y + self.gunOffset);
					local distance = math.sqrt(distX ^ 2 , distY ^ 2);
					local found = SceneMan:CastMORay(Vector(self.Pos.X, self.Pos.Y + self.gunOffset), Vector(distX, distY), self.ID, 128, false, 2);
					local foundRoot = MovableMan:GetRootMOID(found);
					if self.target:IsDead() or foundRoot ~= self.target.ID or distance > self.sensorRange then
						self.target = nil;
					else
						local targetVector = Vector(0,0);
						targetVector.X = self.target.Pos.X - self.Pos.X;
						targetVector.Y = self.target.Pos.Y - (self.Pos.Y + self.gunOffset);
						
						local targetAngle = math.atan2(targetVector.Y, targetVector.X) * -1;
						if targetAngle > math.pi / 2 or targetAngle < math.pi / -2 then
							ownController:SetState(Controller.MOVE_LEFT, true);
						else
							ownController:SetState(Controller.MOVE_RIGHT, true);
						end
						if targetAngle > math.pi / 2 then
							targetAngle = math.pi - targetAngle;
						end
						if targetAngle < math.pi / -2 then
							targetAngle = (math.pi * -1) - targetAngle;
						end
						self:SetAimAngle(targetAngle);
						ownController:SetState(Controller.WEAPON_FIRE, true);
					end
				else
					self.target = nil;
				end
			end
		end
		
		if self:GetAimAngle(false) > self.aimThreshold then
			ownController:SetState(Controller.WEAPON_FIRE, false);
			self:SetAimAngle(self.aimThreshold);
			self.target = nil;
		end
		
		if ownController:IsState(Controller.HOLD_LEFT) then
			self.Vel.X = self.Vel.X - self.acceleration;
			if self.Vel.X < -self.maxSpeed then
				self.Vel.X = -self.maxSpeed;
			end
		elseif ownController:IsState(Controller.HOLD_RIGHT) then
			self.Vel.X = self.Vel.X + self.acceleration;
			if self.Vel.X > self.maxSpeed then
				self.Vel.X = self.maxSpeed;
			end
		elseif self.Vel.X < 0 then
			self.Vel.X = self.Vel.X + self.acceleration;
			if self.Vel.X > 0 then
				self.Vel.X = 0;
			end
		elseif self.Vel.X > 0 then
			self.Vel.X = self.Vel.X - self.acceleration;
			if self.Vel.X < 0 then
				self.Vel.X = 0;
			end
		end
		if ownController:IsState(Controller.HOLD_UP) then
			self.Vel.Y = self.Vel.Y - self.acceleration;
			if self.Vel.Y < -self.maxSpeed then
				self.Vel.Y = -self.maxSpeed;
			end
		elseif ownController:IsState(Controller.HOLD_DOWN) then
			self.Vel.Y = self.Vel.Y + self.acceleration;
			if self.Vel.Y > self.maxSpeed then
				self.Vel.Y = self.maxSpeed;
			end
		elseif self.Vel.Y < 0 then
			self.Vel.Y = self.Vel.Y + self.acceleration;
			if self.Vel.Y > 0 then
				self.Vel.Y = 0;
			end
		elseif self.Vel.Y > 0 then
			self.Vel.Y = self.Vel.Y - self.acceleration;
			if self.Vel.Y < 0 then
				self.Vel.Y = 0;
			end
		end
				
		self.Vel.Y = self.Vel.Y - self.gravAcc;
		
		--self.RotAngle = self.rotFactor * -(self.Vel.X / self.maxSpeed);
		self.RotAngle = self.RotAngle / 2;
	end
	
--SIDE GUNS
	if MovableMan:IsActor(self.RSide) then
		self.RSide.Pos = Vector(self.Pos.X + self.sideOffset.X, self.Pos.Y + self.sideOffset.Y);
		self.RSide.RotAngle = self.RotAngle;
		self.RSide.Vel = self.Vel;
		if self.RSide:GetAimAngle(true) > 0.5 or self.RSide:GetAimAngle(true) < -0.5 then
			self.RSide:SetAimAngle(0);
		end
		self.RSide.HFlipped = false;
	end
	if MovableMan:IsActor(self.LSide) then
		self.LSide.Pos = Vector(self.Pos.X - self.sideOffset.X, self.Pos.Y + self.sideOffset.Y);
		self.LSide.RotAngle = self.RotAngle;
		self.LSide.Vel = self.Vel;
		if self.LSide:GetAimAngle(false) > 0.5 or self.LSide:GetAimAngle(false) < -0.5 then
			self.LSide:SetAimAngle(3.14);
		end
		self.LSide.HFlipped = true;
	end
	if self:IsDead() then
		if MovableMan:IsActor(self.RSide) then
			self.RSide.ToDelete = true;
		end
		if MovableMan:IsActor(self.LSide) then
			self.LSide.ToDelete = true;
		end
	end
	if self.RSide:IsPlayerControlled() then
		self.RSide:SetControllerMode(Controller.CIM_AI,-1);
	end
	if self.LSide:IsPlayerControlled() then
		self.LSide:SetControllerMode(Controller.CIM_AI,-1);
	end
	
--SPAWN
    local blocked = false;
    --Check if the spawn point is blocked.
    for actor in MovableMan.Actors do
		if actor.Pos.Magnitude - self.Pos.Magnitude < 25 and actor.Pos.Magnitude - self.Pos.Magnitude > -25 and actor.ID ~= self.ID and actor.PresetName ~= "Side" then
			blocked = true;
		end
    end

    --If the timer is past the interval time, the game has started and there is no blockage...
    if self.spawnTimer:IsPastSimMS(self.spawnInterval) and ActivityMan.ActivityState ~= Activity.EDITING and blocked == false then
		--Create the actor.
		local spawn = CreateAHuman("Necron Warrior");
		--Create the actor's weapon.
		local weapon = CreateHDFirearm("Gauss Flayer");
		--Give the actor its weapon.
		spawn:AddInventoryItem(weapon);
		--Set the actor's position.
		spawn.Pos = self.Pos + self.offset;
		--Set the actor's team.
		spawn.Team = self.Team;
		--Set the actor's AI mode so that it won't get stuck in the Monolith.
		spawn.AIMode = Actor.AIMODE_SENTRY;
		--Add the actor.
		MovableMan:AddActor(spawn);
		self.spawnTimer:Reset();
    end
	
--REGENERATION
	if self.regenTimer:IsPastSimMS(3000) and self.Health < 100 then
		self.Health = self.Health + 2;
		self.regenTimer = Timer();
	end
end

function Destroy(self)
--SIDE GUNS
	if MovableMan:IsActor(self.RSide) then
		self.RSide.ToDelete = true;
	end
	if MovableMan:IsActor(self.LSide) then
		self.LSide.ToDelete = true;
	end
end
